
/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.remote;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;

import net.micode.notes.R;
import net.micode.notes.ui.NotesListActivity;
import net.micode.notes.ui.NotesPreferenceActivity;

//定义了一个类GTaskASyncTask，继承自AsyncTask类。AsyncTask是一个抽象类，定义了异步任务的处理流程，开发者需要实现其抽象方法来处理具体的任务。
public class GTaskASyncTask extends AsyncTask<Void, String, Integer> {
//定义一个静态的通知ID
    private static int GTASK_SYNC_NOTIFICATION_ID = 5234235;
//定义一个接口OnCompleteListener，包含一个方法onComplete()。在任务完成时，调用该接口的onComplete()方法，通知任务执行完毕。
    public interface OnCompleteListener {
        void onComplete();
    }
//定义了一些成员变量，包括上下文、通知管理器、任务管理器和任务完成的监听器。
    private Context mContext;

    private NotificationManager mNotifiManager;

    private GTaskManager mTaskManager;

    private OnCompleteListener mOnCompleteListener;
//构造函数，初始化类中的成员变量。
    public GTaskASyncTask(Context context, OnCompleteListener listener) {
        mContext = context;
        mOnCompleteListener = listener;
        mNotifiManager = (NotificationManager) mContext
                .getSystemService(Context.NOTIFICATION_SERVICE);
        mTaskManager = GTaskManager.getInstance();
    }
//定义了cancelSync()方法，用于取消同步任务
    public void cancelSync() {
        mTaskManager.cancelSync();
    }
//定义了publishProgess()方法，用于发布同步进度。
    public void publishProgess(String message) {
        publishProgress(new String[] {
            message
        });
    }
/*定义了showNotification()方法，用于显示同步任务的通知。该方法接受两个参数，第一个参数tickerId用于标识通知的类型，
    第二个参数content用于显示通知内容。在该方法中，首先创建一个Notification对象，然后设置一些通知属性，例如图标、默认的提示灯等。
    接下来，根据tickerId的值，创建一个PendingIntent对象，分别对应同步成功和同步失败的情况，最后调用NotificationManager的notify()方法，将通知发送到通知栏中。
 */
    private void showNotification(int tickerId, String content) {
        Notification notification = new Notification(R.drawable.notification, mContext
                .getString(tickerId), System.currentTimeMillis());
        notification.defaults = Notification.DEFAULT_LIGHTS;
        notification.flags = Notification.FLAG_AUTO_CANCEL;
        PendingIntent pendingIntent;
        if (tickerId != R.string.ticker_success) {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesPreferenceActivity.class), 0);

        } else {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesListActivity.class), 0);
        }
        notification.setLatestEventInfo(mContext, mContext.getString(R.string.app_name), content,
                pendingIntent);
        mNotifiManager.notify(GTASK_SYNC_NOTIFICATION_ID, notification);
    }

    @Override
    //doInBackground() 方法是在新的线程中执行的，主要是用来执行耗时操作。在这里，它调用了 publishProgress() 方法来通知 UI 线程更新进度，然后调用了 mTaskManager.sync() 方法来进行同步操作。
    protected Integer doInBackground(Void... unused) {
        publishProgess(mContext.getString(R.string.sync_progress_login, NotesPreferenceActivity
                .getSyncAccountName(mContext)));
        return mTaskManager.sync(mContext, this);
    }

    @Override
    //onProgressUpdate() 方法在 UI 线程中执行，它用来更新 UI。在这里，它调用了 showNotification() 方法来显示通知，并且如果当前的 mContext 对象是 GTaskSyncService 的实例，它还会发送一个广播
    protected void onProgressUpdate(String... progress) {
        showNotification(R.string.ticker_syncing, progress[0]);
        if (mContext instanceof GTaskSyncService) {
            ((GTaskSyncService) mContext).sendBroadcast(progress[0]);
        }
    }

    @Override
    /*onPostExecute() 方法在 UI 线程中执行，它用来处理异步任务执行完毕后的结果。
    根据 mTaskManager.sync() 的返回值，它会调用 showNotification() 方法来显示不同的通知。如果 mOnCompleteListener 不为 null，
    它还会在一个新线程中执行 mOnCompleteListener.onComplete() 方法
   */
    protected void onPostExecute(Integer result) {
        if (result == GTaskManager.STATE_SUCCESS) {
            showNotification(R.string.ticker_success, mContext.getString(
                    R.string.success_sync_account, mTaskManager.getSyncAccount()));
            NotesPreferenceActivity.setLastSyncTime(mContext, System.currentTimeMillis());
        } else if (result == GTaskManager.STATE_NETWORK_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_network));
        } else if (result == GTaskManager.STATE_INTERNAL_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_internal));
        } else if (result == GTaskManager.STATE_SYNC_CANCELLED) {
            showNotification(R.string.ticker_cancel, mContext
                    .getString(R.string.error_sync_cancelled));
        }
        if (mOnCompleteListener != null) {
            new Thread(new Runnable() {

                public void run() {
                    mOnCompleteListener.onComplete();
                }
            }).start();
        }
    }
}
